unit TokenizationClass;

interface

type
  TTokenHandler = procedure(Sender: TObject; const Token: String; Line: Integer) of object;

  TTokenization = class
  private
    FCurrentLine: Integer;
  protected
    CurrentToken: String;
    procedure AddToToken(C: Char);
    procedure IncreaseLine;
    procedure DoToken(HandleToken: TTokenHandler; C: Char);
  public
    property CurrentLine: Integer read FCurrentLine;
    procedure Initialize; virtual;
    function ProcessCharacter(C: Char; HandleToken: TTokenHandler; var Reverse: Integer): Boolean; virtual; abstract;
  end;

implementation

procedure TTokenization.AddToToken(C: Char);
begin
  CurrentToken := CurrentToken + C;
end;

procedure TTokenization.DoToken(HandleToken: TTokenHandler; C: Char);
begin
  if CurrentToken <> '' then
  begin
    HandleToken(Self, CurrentToken, CurrentLine);
    CurrentToken := '';
  end;
  if C = #10 then
    IncreaseLine;
end;

procedure TTokenization.IncreaseLine;
begin
  Inc(FCurrentLine);
end;

procedure TTokenization.Initialize;
begin
  FCurrentLine := 1;
  CurrentToken := '';
end;

end.
