unit WordTokenizationClass;

interface

uses
  TokenizationClass;

type
  TWordTokenization = class(TTokenization)
  public
    function ProcessCharacter(C: Char; HandleToken: TTokenHandler; var Reverse: Integer): Boolean; override;
  end;

implementation

const
  Punctuations = ['.', ',', ';', ':', '(', ')', '{', '}', '[', ']', '!',
                  '?', '=', '<', '>', '+', '-', '*', '/'];

function TWordTokenization.ProcessCharacter(C: Char; HandleToken: TTokenHandler; var Reverse: Integer): Boolean;
begin
  if C in [#0, #10, #13, ' '] then
    DoToken(HandleToken, C)
  else if C in Punctuations then
  begin
    DoToken(HandleToken, C);
    AddToToken(C);
    DoToken(HandleToken, C);
  end
  else
    AddToToken(C);
  Result := True;
end;

end.
